/*
 
 Copyright 2011 ANDREA TUCCI <falko91@aliceposta.it>
 
 This file is part of BOMBERTUX.
 
 BOMBERTUX is free software: you can redistribute it and/or
 modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 BOMBERTUX is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with BOMBERTUX.  If not, see
 <http://www.gnu.org/licenses/>.
 
 */
#include "Bomb.h"
#include "Bombertux.h"
#include <panel.h>

Bomb::Bomb (unsigned pow, int tim,bool avail,bool drop,int x,int y)
:power(pow),timeForExplosion(tim),dropped(drop),originX(x),originY(y)
{
	setAvailability(avail);
	animation=0;
	
	
}


void Bomb::setDrop(bool dropped)
{
	this->dropped=dropped;
}
bool Bomb::isDropped()const
{
	return dropped;
}

void Bomb::setAvailability(bool aval)
{
	available=aval;
}

void Bomb::setPower(unsigned pow)
{
	power=pow;
}

bool Bomb::getAvailability()const
{
	return available;
}
unsigned Bomb::getPower()const
{
	return power;
}

int Bomb::getTime()const
{
	return timeForExplosion;
}

void Bomb::setTime(int time)
{
	if(time>=0)
		timeForExplosion=time;
	else
		timeForExplosion=5;
}

void Bomb::explode (int l,int c,int time,char button)
{
	
	attron(COLOR_PAIR(1));
	
	if (dropped==false)
	{
		if(button=='b')
		{
			//+2 per farla cadere sotto piedi di bombertux
			originY=(l+2);
			originX=(c+2);
			
		}
		if(button=='n')
		{
			//per farla cadere a dx

			originY=(l+1);
			originX=(c+5);
			
			
		}
		if(button=='v')
		{
			//per farla cadere a sx

			originY=(l+1);
			originX=(c-1);
			
			//mvprintw(10,10,"%d",originX-power);
			
		}
		if(Maze::control[originY][originX]=='L'|| Maze::control[originY][originX]=='T')
		{
			mvprintw(originY,originX,"O");
			
			dropped=true;
			
			Maze::control[originY][originX]='O';
		}
		refresh();
	}
	Maze::control[originY][originX]='O';
	
	
	int timePassed= (time - timeDropped);
	if (dropped==true)
	{
		if(timePassed % 2==0 )
		{
				
			mvprintw(originY,originX,"o");
			animation++;
		}
		else
    		{
    			
			mvprintw(originY,originX,"O");
			animation++;
		}	
		if(timePassed >=5)
		{	
			mvprintw(originY,originX," ");
			attron (COLOR_PAIR(1));
				
			if(originX+power<100)
				if(Maze::control[originY][originX+power]!='M')
					mvprintw(originY,originX+power,">");
			int test=originX-power;
			
			if(test >= 0)
				if(Maze::control[originY][test]!='M')
					mvprintw(originY,test,"<");
			
			if(originY+power <30)
				if(Maze::control[originY+power][originX]!='M')
					mvprintw(originY+power,originX,"v");
			if(originY-power >=0);
				if(Maze::control[originY-power][originX]!='M')
					mvprintw(originY-power,originX,"^");
			
			refresh();
			usleep(20000);
			
			dropped=false;
			WINDOW* expl=newwin (20,100,10,0);
			PANEL* explosion=new_panel(expl);
			update_panels();
			for(int i=0;i<2;i++)
			{
				wbkgd(expl,COLOR_PAIR(6));
				timeout(50);
				getch();
				doupdate();
					
			}
			del_panel(explosion);
			delwin(expl);
			Maze::control[originY][originX]='L';
			deleteIfPossible(originY,originX,' ');
			refresh();
				
		}
			
	}
			
refresh();
}

void Bomb::deleteIfPossible(int y,int x,const char symbol)const
{
	int l;
	if(y-power<0)
		l=0;
	else
		l=y-power;
	int max;
	if(y+power >30)
		max=29;
	else
		max=y+power;
	   
	
		for(;l<=max;l++)
		{
			bool finded=false;
			if(Maze::control[l][x]=='B')
			{
				attron(COLOR_PAIR(15));

					if(rand()%8==0) // Potenza della bomba aumentata
					{
						Maze::control[l][x]='!';
						mvaddch(l,x,'!');
						finded=true;
					}
					
					if(rand()%8==0) // Bomba doppia
					{
						Maze::control[l][x]='*';
						mvaddch(l,x,'*');
						finded=true;
					
					}
					
					if(rand()%10==0)	//Vita
					{
						Maze::control[l][x]='V';
						mvaddch(l,x,'L');
						finded=true;
					}
					
					if(rand()%6==0)	//Punti
					{
						Maze::control[l][x]='$';
						mvaddch(l,x,'$');
						finded=true;
					}
					
					if(rand()%30==0) //Blaster
					{
						Maze::control[l][x]='>';
						mvaddch(l,x,'>');
						finded=true;
					}
					
					
					if(!finded)
					{
						Maze::control[l][x]='L';
						mvaddch(l,x,symbol);
					}
					
					refresh();
					
			}
			
			else
			{
			if(Maze::control[l][x]=='T')
				Bombertux::setDeath(true);
			if(Maze::control[l][x]=='X')
				Maze::control[l][x]=' ';
			else
				if(Maze::control[l][x]!='M')
				{
					Maze::control[l][x]='L';
					mvaddch(l,x,symbol);
				}
			}
		}
				
	int c;
	if(x-power<0)
		c=0;
	else
		c=x-power;
	
	if(x+power >100)
		max=99;
	else
		max=x+power;
	
		for(;c<=max;c++)
		{
			bool finded=false;
	 		if(Maze::control[y][c]=='B')
			{
				attron(COLOR_PAIR(15));
				if(rand()%8==0)
				{
					Maze::control[y][c]='!';
					mvaddch(y,c,'!');
					finded=true;
				}
				
				if(rand()%8==0)
				{
					Maze::control[y][c]='*';
					mvaddch(y,c,'*');
					finded=true;
					
				}
				
				if(rand()%10==0)
				{
					Maze::control[y][c]='V';
					mvaddch(y,c,'L');
					finded=true;
				}
				if(rand()%6==0)
				{
					Maze::control[y][c]='$';
					mvaddch(y,c,'$');
					finded=true;
				}
				if(rand()%30==0)
				{
					Maze::control[y][c]='>';
					mvaddch(y,c,'>');
					finded=true;
				}
				if(!finded)
				{
					Maze::control[y][c]='L';
					mvaddch(y,c,symbol);
				}
				
			}
			else
			{
				if(Maze::control[y][c]=='T')
					Bombertux::setDeath(true);
				if(Maze::control[y][c]=='X')
					Maze::control[y][c]=' ';
				else
					if(Maze::control[y][c]!='M')
					{
						Maze::control[y][c]='L';
						mvaddch(y,c,symbol);
					}
			}
			
				
			
				
		
			
		}
	
}

void Bomb::setTimeDropped(int time)
{
	timeDropped=time;
}	



