/*
 
 Copyright 2011 ANDREA TUCCI <falko91@aliceposta.it>
 
 This file is part of BOMBERTUX.
 
 BOMBERTUX is free software: you can redistribute it and/or
 modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 BOMBERTUX is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with BOMBERTUX.  If not, see
 <http://www.gnu.org/licenses/>.
 
 */
#include "Bombertux.h"
#include <cassert>
#include <cstdlib>
#include <panel.h>
#include "Stats.h"


Bombertux::Bombertux(int l)
:life(l),usingBomb(0),twoBombs(false)
{
}


bool Bombertux::dead=false;
//metterre il controllo assert su dead

int Bombertux::getLife()const
{
	return life;
}

bool Bombertux::isDead()
{
	return dead;
}

void Bombertux::addBomb(Bomb& bomb)
{
	bombs.push_back(&bomb);
}
void Bombertux::setLife(int l)
{
	assert(l>=0);
	life=l;
}
void Bombertux::moveTux(int& topX,int& topY,int& middX,int& middY,int& bottomX,int& bottomY,int tempo,int& currLife)
{
	
	int c;
	attron(COLOR_PAIR(1));
	timeout(0);
	c=getch();

		checkLife(topY,topX);
		if(c==KEY_RIGHT && Maze::isFreeForTux(topY,topX+1)!=0)
		
		{
			
			getPowerUp(topY,topX+1,currLife);
			move(topY,topX);
			mvprintw(topY,topX,"    ");
			mvprintw(middY,middX,"     ");
			mvprintw(bottomY,bottomX,"     ");
		
			attron(COLOR_PAIR(1));
			mvprintw(topY,(topX+1)," _\\_ ");
			attron(COLOR_PAIR(12));
			mvprintw(middY,(middX+1),"(| |)");
			attron(COLOR_PAIR(1));
			mvprintw(bottomY,(bottomX+1),"  ^  ");
			if(Maze::isFreeForTux(topY,topX+1)==2)
				dead=true;
			
			for(int i=0;i<5;i++)
			{
			Maze::control[topY][topX+i]='L';
			Maze::control[middY][middX+i]='L';
			Maze::control[bottomY][bottomX+i]='L';
			}
		
			topX++;
			middX++;
			bottomX++;
			
		}
	if(c==KEY_DOWN && Maze::isFreeForTux(topY+1,topX)!=0)
	{
		getPowerUp(topY+1,topX,currLife);
		move(topY,topX);
		mvprintw(topY,topX,"    ");
		mvprintw(middY,middX,"     ");
		mvprintw(bottomY,bottomX,"     ");
		attron(COLOR_PAIR(1));
		mvprintw((topY+1),topX," _\\_ ");
		attron(COLOR_PAIR(12));
		mvprintw((middY+1),middX,"(| |)");
		attron(COLOR_PAIR(1));
		mvprintw((bottomY+1),bottomX,"  ^  ");
		if(Maze::isFreeForTux(topY+1,topX)==2)
			dead=true;
		for(int i=0;i<5;i++)
		{
		Maze::control[topY][topX+i]='L';
		Maze::control[middY][middX+i]='L';
		Maze::control[bottomY][bottomX+i]='L';
		}
		
		topY++;
		middY++;
		bottomY++;
		
		
	}	
	if(c==KEY_LEFT && Maze::isFreeForTux(topY,topX-1)!=0)
	{
		getPowerUp(topY,topX-1,currLife);
		move(topY,topX);
		mvprintw(topY,topX,"    ");
		mvprintw(middY,middX,"     ");
		mvprintw(bottomY,bottomX,"     ");
		attron(COLOR_PAIR(1));
		mvprintw(topY,topX-1," _\\_ ");
		attron(COLOR_PAIR(12));
		mvprintw(middY,middX-1,"(| |)");
		attron(COLOR_PAIR(1));
		mvprintw(bottomY,bottomX-1,"  ^  ");
		if(Maze::isFreeForTux(topY,topX-1)==2)
				dead=true;
		for(int i=0;i<5;i++)
		{
		Maze::control[topY][topX+i]='L';
		Maze::control[middY][middX+i]='L';
		Maze::control[bottomY][bottomX+i]='L';
		}
		
		topX--;
		middX--;
		bottomX--;
	
	}
	if(c==KEY_UP  && Maze::isFreeForTux(topY-1,topX)!=0)
	{
		getPowerUp(topY-1,topX,currLife);
		move(topY,topX);
		mvprintw(topY,topX,"    ");
		mvprintw(middY,middX,"     ");
		mvprintw(bottomY,bottomX,"     ");
		attron(COLOR_PAIR(1));
		mvprintw((topY-1),topX," _\\_ ");
		attron(COLOR_PAIR(12));
		mvprintw((middY-1),middX,"(| |)");
		attron(COLOR_PAIR(1));
		mvprintw((bottomY-1),bottomX,"  ^  ");
		if(Maze::isFreeForTux(topY-1,topX)==2)
				dead=true;
		for(int i=0;i<5;i++)
		{
		Maze::control[topY][topX+i]='L';
		Maze::control[middY][middX+i]='L';
		Maze::control[bottomY][bottomX+i]='L';
		}
		
		topY--;
		middY--;
		bottomY--;
		
	}
	if( (c=='b'|| c=='n' || c=='v') && (bombs[usingBomb]->isDropped()==false || bombs[1]->isDropped()==false) )
	{
		
		if(bombs[usingBomb]->isDropped()==false)
		{
			bombs[usingBomb]->setTimeDropped(tempo);
			bombs[usingBomb]->explode(topY,topX,tempo,c);
		}
		if(twoBombs && bombs[usingBomb]->isDropped() && usingBomb!=2)
		{
			bombs[1]->setTimeDropped(tempo);
			bombs[1]->explode(topY,topX,tempo,c);
		}	
	}


	if(c=='w' && bombs[usingBomb]->isDropped()==false)
	{
		char x;
		x=Stats::weapons(*this);
		attron(COLOR_PAIR(7));
		if(x=='n')
			usingBomb=0;
		if(x=='b' && bombs[2]->getAvailability()==true)
			usingBomb=2;
	}
	if(c=='p')
	{
		Stats::pause();
	}
	
		


	//ciclo bombe

	if(bombs[usingBomb]->isDropped())
		bombs[usingBomb]->explode(topY,topX,tempo,c);
	if(bombs[1]->isDropped())
		bombs[1]->explode(topY,topX,tempo,c);

	for(int i=0;i<5;i++)
	{
		Maze::control[topY][topX+i]='T';
		Maze::control[middY][middX+i]='T';
		Maze::control[bottomY][bottomX+i]='T';
		
	}
	checkLife(topY,topX);
	
	if(dead)
		deathAnimation(topX,topY,middX,middY,bottomX,bottomY);
		

	
}

void Bombertux::setDeath (bool d)
{
	Bombertux::dead=d;
}

void Bombertux::checkLife(int topY,int topX)
{
	for(int y=topY;y<topY+3;y++)
		for(int x=topX;x<topX+5;x++)
			if(Maze::control[y][x]!='T' && Maze::control[y][x]!='O')
				dead=true;
	
}

void Bombertux::deathAnimation(int topX,int topY,int middX,int middY,int bottomX,int bottomY)
{
	WINDOW* loseLife= newwin(10,30,15,40);
	box(loseLife,'*','*');
	PANEL* lose=new_panel(loseLife);
	update_panels();
	doupdate();
	char c;
	mvwprintw(loseLife,2,2,"You lose a Life!");
	mvwprintw(loseLife,3,2,"Press 'c' key to continue");
	attron(COLOR_PAIR(1));
	mvprintw(topY,topX," _\\_ ");
	attron(COLOR_PAIR(12));
	mvprintw(middY,middX,"(x x)");
	attron(COLOR_PAIR(1));
	mvprintw(bottomY,bottomX,"  ^  ");
	refresh();
	do
	{
		timeout(0);
		c=wgetch(loseLife);
	}
	while(c!='c');
	del_panel(lose);
	delwin(loseLife);
	mvprintw(topY,topX,"     ");
	mvprintw(middY,middX,"     ");
	mvprintw(bottomY,bottomX,"     ");
	for(int i=topY;i<topY+3;i++)
		for(int j=topX;j<topX+5;j++)
			Maze::control[i][j]='L';
	refresh();
	life--;
	dead=false;
	
}

void Bombertux::getPowerUp (int y,int x,int& currLife)
{
	for(int l=y;l<y+3;l++)
		for(int c=x;c<x+5;c++)
		{
			if(Maze::control[l][c]=='>')
			{
				Maze::control[l][c]='L';
				bombs[2]->setAvailability(true);
			}
			if(Maze::control[l][c]=='V')
			{
				Maze::control[l][c]='L';
				life+=1;
				currLife++;
			}
			if(Maze::control[l][c]=='$')
			{
				Maze::control[l][c]='L';
				Stats::setPoints(Stats::getPoints()+250);
			}
			if(Maze::control[l][c]=='!')
			{
				Maze::control[l][c]='L';
				if(bombs[0]->getPower()<5)
				{
				bombs[0]->setPower(bombs[0]->getPower()+1);
				bombs[1]->setPower(bombs[1]->getPower()+1);
				}
			}
			if(Maze::control[l][c]=='*')
			{
				Maze::control[l][c]='L';
				twoBombs=true;
				
			}
		}		
			
}
const vector<Bomb*>& Bombertux::getBombs()const
{
	return bombs;
}
bool Bombertux::canDropTwoBombs()const
{
	return twoBombs;
}
bool Bombertux::hasThisBomb(int bomb)const
{
	return bombs[bomb]->getAvailability();
}

