/*
 
 Copyright 2011 ANDREA TUCCI <falko91@aliceposta.it>
 
 This file is part of BOMBERTUX.
 
 BOMBERTUX is free software: you can redistribute it and/or
 modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 BOMBERTUX is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with BOMBERTUX.  If not, see
 <http://www.gnu.org/licenses/>.
 
 */
#include "CommonMonster.h"
#include <cstdlib>
#include <ctime>
#include "Maze.h"

CommonMonster::CommonMonster(const string& base,int vel,int nol,int y, int x,bool strng,bool shoot)
:Monster(base,vel,nol,y,x,strng,shoot)
{}

void CommonMonster::draw()
{
	attron(COLOR_PAIR(1));
	srand(time(0));
	bool find=false;
	int c,l;
 do
 {
	c=rand() % 100;
	l=rand() % 30;
	
	

	if(Maze::isFreeSpaceForMonster(l,c,getNumberOfLines(),baseComposition.length()) && l>(Maze::getBeginOfMaze()+4) )
	{
		mvprintw(l,c,getBaseComposition().data());
		for(int i=0;i<baseComposition.length();i++)
			Maze::control[l][c+i]='X';
		find=true;
	}
 }
	while(find==false);

	setOrigins(l,c);
	
}

void CommonMonster::moveMonster()
{
	
	//0-> giu, 1->su, 2->sx, 3->dx
	attron(COLOR_PAIR(1));
    int move=rand()%4;
	switch(move)
    {
		case 0:
			if(Maze::isFreeSpaceForMonster(originY+1,originX,numberOfLines,baseComposition.length()) )
			{
				if(strong)
					mvprintw(originY,originX,"       ");
				else
				mvprintw(originY,originX,"     ");
				
				mvprintw((originY+1),originX,baseComposition.data());
				for(int c=0;c<baseComposition.length();c++)
				{
					Maze::control[originY][originX+c]='L';
					Maze::control[originY+1][originX+c]='X';
				}	
				originY+=1;
			}
			break;
		case 1:
			if(Maze::isFreeSpaceForMonster(originY-1,originX,numberOfLines,baseComposition.length()) )
			{
				if(strong)
					mvprintw(originY,originX,"       ");
				else
				mvprintw(originY,originX,"     ");
				
				mvprintw((originY-1),originX,baseComposition.data());
				for(int c=0;c<baseComposition.length();c++)
				{
					Maze::control[originY][originX+c]='L';
					Maze::control[originY-1][originX+c]='X';
				}	
				originY-=1;
				
			}
			break;
		case 2:
			if(Maze::isFreeSpaceForMonster(originY,originX-baseComposition.length(),numberOfLines,baseComposition.length()) )
			{
				if(strong)
					mvprintw(originY,originX,"       ");
				else
				mvprintw(originY,originX,"     ");
				
				mvprintw(originY,(originX-1),baseComposition.data());

				Maze::control[originY][originX+baseComposition.length()-1]='L';
				Maze::control[originY][originX-1]='X';
					
				originX-=1;
			
			}
			break;
		case 3:
			if(Maze::isFreeSpaceForMonster(originY,originX+baseComposition.length(),numberOfLines,baseComposition.length()) )
			{
				if(strong)
					mvprintw(originY,originX,"       ");
				else
				mvprintw(originY,originX,"     ");
				
				mvprintw(originY,(originX+1),baseComposition.data());
				
				Maze::control[originY][originX]='L';
				Maze::control[originY][originX+baseComposition.length()]='X';
				
				originX+=1;
				
			}
			break;
		
			
			
    }
    
    
}

bool CommonMonster::checkLife ()
{
	for(int i=originY;i<originY+numberOfLines;i++)
		for(int j=originX;j<originX+baseComposition.length();j++)
		{
			if(Maze::control[i][j]=='T')
				return true;
			
			else
				if(Maze::control[i][j]==' ')
					return false;
		}
	return true;
}

void	 CommonMonster::killed()
{
	for(int i=originY;i<originY+numberOfLines;i++)
		for(int j=originX;j<originX+baseComposition.length();j++)
		{
			mvaddch(i,j,' ');
			Maze::control[i][j]='L';
		}
	dead=true;
}



