/*
 
 Copyright 2011 ANDREA TUCCI <falko91@aliceposta.it>
 
 This file is part of BOMBERTUX.
 
 BOMBERTUX is free software: you can redistribute it and/or
 modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
 
 BOMBERTUX is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with BOMBERTUX.  If not, see
 <http://www.gnu.org/licenses/>.
 
 */
#ifndef MONSTER_H
#define MONSTER_H
#include <string>
#include <cassert>
#include <ncurses.h>
#include "Maze.h"
using namespace std;
class Monster
{
	
	protected:
		string baseComposition;
		int velocity;
		int numberOfLines;
		int timeForMove;
		int originY,originX;
		int originShootY,originShootX;
		bool shooted;
		bool dead;
		bool strong;
	public:
		Monster (const string& compos= "(o.o)",int velocity=1,int nol=1,int y=10,int x=10,bool strng=false,bool shoot=false)
		:numberOfLines(nol),originY(y),originX(x),strong(strng),shooted(shoot)
		{
			assert(velocity >=0);
			this->velocity=velocity;
			assert(compos!="");
			baseComposition=compos;
			dead=false;
			
		}
		
		virtual void moveShoot()=0;
		virtual void draw()=0;
		virtual void moveMonster()=0;
		virtual void killed()=0;
		virtual bool checkLife()=0;
		virtual void shoot(int)=0;
		virtual bool hasShooted()
		{
			return shooted;
		}
		
		
		bool isStrong()
		{
			return strong;
		}
		
		void setVelocity(int v)
		{
			assert(v>=0);
			velocity=v;
		}
		int getVelocity ()
		{
			return velocity;
		}
		int getNumberOfLines () const
		{
			return numberOfLines;
		}
		string getBaseComposition()const
		{
			return baseComposition;
		}
		void setTimeForMove(int time)
		{
			timeForMove=time;
		}
		void setOrigins(int y,int x)
		{
			originY=y;
			originX=x;// devono essere convalidate
		}
		int getX()const
		{
			return originX;
			
		}
		int getY()const
		{
			return originY;
		}
		void setY(int y)
		{
			originY=y;
		}
		void setX(int x)
		{
			originX=x;
		}
		bool isDead()
		{
			return dead;
		}
		void setDeath(bool d)
		{
			dead=d;
		}
		void reDraw(int y)
		{
			for(int l=y;l<y+numberOfLines;l++)
			{
				mvprintw(l,originX,baseComposition.data());
				Maze::control[l][originX]='X';
			}
		}
		virtual void delShoot()
		{
		mvprintw(originShootY,originShootX,"    ");
		for(int i=0;i<4;i++)
			Maze::control[originShootY][originShootX+i]='L';
		}
	
	
		
		virtual ~Monster()
		{}
		

};

#endif
